// TODO add quick explanation of the functionality in this file.

#define ROUND_OVER_INDEX 12
#define NUMBER_SIZE 6

void game_startup()
{
  output_string(NERDLE_STR, 1, 1);
  delay(1500);
  output_string(WAYNEANDLAYNE_COM_NERDLE_STR, 1, 1);
  delay(1500);
}

void display_word(byte cID, unsigned int wID)
{
  char buf[33]; // TODO why 33?
  get_word(cID, wID, buf);
  output_string(buf, 1, 1);
}


void display_word_with_score(byte cID, unsigned int wID, unsigned int score)
{
  lcd.clear();
  lcd.print("Score:");
  lcd.setCursor(7, 0);
  lcd.print(score);
  lcd.setCursor(0, 1);
  char buf[16];
  get_word(cID, wID, buf);
  lcd.print(buf);
  delay(100);
  
}

// Sends the specified buffer to the serial port and/or the LCD
void output_string(char* buffer, boolean output_serial, boolean output_lcd)
{
  /*
  if (output_serial)
  {
    Serial.println(buffer);
  }
  */
  if (output_lcd)
  {
    lcd_print(buffer);
  }
}

// Print the specified buffer to the LCD. 
void lcd_print(char* buffer)
{
  // For printing two lines, need to trim the string at LCD_COLS characters.
  // We save that character to a temp char, edit the buffer to replace it
  // with a '\0', print the string, and then restore that character.
  lcd.clear();
  char temp;
  unsigned char len = strlen(buffer);
  if (len > LCD_COLS)
  {
    // print line 1
    temp = buffer[LCD_COLS]; // save the char
    buffer[LCD_COLS] = '\0'; // end the string
    lcd.print(buffer);
    buffer[LCD_COLS] = temp; // restore the char
    // print line 2
    lcd.setCursor(0, 1);
    if (len > (LCD_COLS<<1))
    {
      // too long for lcd, need to trim string
      buffer[2 * LCD_COLS] = '\0';
    }
    lcd.print(buffer + LCD_COLS);
  }
  else // only one line, so we can print directly
  {
    // print line 1
    lcd.print(buffer);
  }
}


//void lcd_test()
//{
//  lcd.clear();
//  lcd.print("Hello world!");
//  delay(500);
//  lcd.print("Hello");
//  lcd.setCursor(1, 0);
//  lcd.print("world!");
//  delay(500);
//  lcd.clear();
//}
//

