/*
Nerdle Library
Wayne and Layne, LLC
http://wayneandlayne.com/nerdle
*/

// ensure this library description is only included once
#ifndef nerdle_h
#define nerdle_h

// include types & constants of Wiring core API
#include <WProgram.h>
#include <LiquidCrystal.h>

/* Hardware Definitions */
// LCD
#define LCD_POWER 0
#define LCD_RS 6
#define LCD_E 5
#define LCD_DB4 10
#define LCD_DB5 11
#define LCD_DB6 12
#define LCD_DB7 13

// Capacitive-touch buttons
#define BUTTON_LF_PIN 16
#define BUTTON_RT_PIN 7
#define BUTTON_UP_PIN 8
#define BUTTON_DN_PIN 15
#define BUTTON_COUNT 5
#define SEND_PIN 17

void init_lcd(LiquidCrystal);

#endif
