/*
 * Based on Obdev's AVRUSB code and under the same license.
 *
 * TODO: Make a proper file header. :-)
 */
#ifndef __UsbStreamMultibyte_h__
#define __UsbStreamMultibyte_h__

#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <string.h>

#include "usbdrv.h"

typedef uint8_t byte;

#include <util/delay.h>     /* for _delay_ms() */

class UsbStreamMultibyteDevice {
 public:
  UsbStreamMultibyteDevice ();

  void begin();
    
  void refresh();

  bool available();

  void read(char* buf, uchar len);

  void write(char* buf, uchar len);

  void end();

};

extern UsbStreamMultibyteDevice UsbStreamMultibyte;

#endif // __UsbStreamMultibyte_h__

