#include <LiquidCrystal.h>
#include <Nerdle.h>
LiquidCrystal lcd(LCD_RS, LCD_E, LCD_DB4, LCD_DB5, LCD_DB6, LCD_DB7); 


int speaker_pin = 9;

void setup()  
{
  init_lcd(lcd);
  lcd.print("Hello!");
}

void one_beep(int frequency)
{
  tone(speaker_pin, frequency);
  delay(100);
  noTone(speaker_pin);
}


void loop()
{
  lcd.clear();
  lcd.print("One low beep");
  one_beep(250);
  delay(200);
  lcd.clear();
  lcd.print("A higher one");
  one_beep(1200);
  delay(200);
  lcd.clear();
  lcd.print("and two fast");
  lcd.setCursor(0,1);
  lcd.print("beeps");
  one_beep(600);
  delay(100);
  one_beep(600);
  delay(100);
}



